import "SandBox.Crafters"

crafters = CraftersWindow()

newcharwin = NewCharWindow()

charwin = {}

shopwin = ShopWindow()

function charwin:Closed( sender, args ) savechar( ) end

crafters.newcharbut.Click = function( sender, args ) newcharwin:SetVisible( true )  end
newcharwin.SaveBut.Click = function( sender, args ) newcharwin:SaveChar( crafters ) gsave() end

crafters.chars = Turbine.PluginData.Load( Turbine.DataScope.Server, "SandboxCrafters" )
if crafters.chars ~= nil then 
    for i in pairs(crafters.chars) do
        crafters:MakeBut( crafters.chars[i] )
    end
else
    crafters.chars = {}
end
function crafters.Closed( sender, args ) gsave() end

CraftersCommand = Turbine.ShellCommand()
function CraftersCommand:Execute( command, args )
    crafters:SetVisible( true )
end

Turbine.Shell.AddCommand( "Craft", CraftersCommand )

function gsave( )
    Turbine.PluginData.Save( Turbine.DataScope.Server, "SandboxCrafters", crafters.chars )
end

function loadchar( data )
    charwin[data.name] = CharWindow()
    charwin[data.name]:Clear()
    charwin[data.name].data = data
    charwin[data.name]:SetText( data.name )
    charwin[data.name].prof1:SetText( data.prof1 )
    charwin[data.name].prof1s:SetText( data.prof1s )
    charwin[data.name].prof1m:SetText( data.prof1m )
    charwin[data.name].prof2:SetText( data.prof2 )
    charwin[data.name].prof2s:SetText( data.prof2s )
    charwin[data.name].prof2m:SetText( data.prof2m )
    charwin[data.name].prof3:SetText( data.prof3 )
    charwin[data.name].prof3s:SetText( data.prof3s )
    charwin[data.name].prof3m:SetText( data.prof3m )
    charwin[data.name].shopwin = ShopWindow()
    charwin[data.name].shopwin:SetText( data.name .. "'s Shopping list" )
    charwin[data.name].shopwin.slist:SetText( data.shoplist )
    charwin[data.name].sbut.Click = function( sender, args ) savechar( data ) charwin[data.name]:SetVisible( false ) gsave() end
    charwin[data.name].dbut.Click = function( sender, args ) deletechar( data ) end
    charwin[data.name].shopbut.Click = function( sender, args ) charwin[data.name].shopwin:SetVisible( true ) end
    charwin[data.name]:SetVisible( true )
end

function  savechar( data )
    charwin[data.name].data.name = charwin[data.name]:GetText()
    charwin[data.name].data.prof1 = charwin[data.name].prof1:GetText()
    charwin[data.name].data.prof1s = charwin[data.name].prof1s:GetText()
    charwin[data.name].data.prof1m = charwin[data.name].prof1m:GetText()
    charwin[data.name].data.prof2 = charwin[data.name].prof2:GetText()
    charwin[data.name].data.prof2s = charwin[data.name].prof2s:GetText()
    charwin[data.name].data.prof2m = charwin[data.name].prof2m:GetText()
    charwin[data.name].data.prof3 = charwin[data.name].prof3:GetText()
    charwin[data.name].data.prof3s = charwin[data.name].prof3s:GetText()
    charwin[data.name].data.prof3m = charwin[data.name].prof3m:GetText()
    charwin[data.name].data.shoplist = charwin[data.name].shopwin.slist:GetText()
    charwin[data.name]:Clear()
    charwin[data.name].shopwin:Clear()
    gsave()
end

function deletechar( data )
    --D Turbine.Shell.WriteLine( "Deleting charicter: " .. data.name )
    charwin[data.name]:SetVisible( false )
    crafters.listbox:RemoveItemAt( data.index )
    crafters.chars[data.name] = nil
    gsave()
end

Turbine.Shell.WriteLine( "Loaded Crafters version 0.6" )
Turbine.Shell.WriteLine( "Type /Craft to bring up the window." )
