import "Turbine"
import "Turbine.UI"
import "Turbine.UI.Lotro"
import "Turbine.Utils"

NewCharWindow = class( Turbine.UI.Window )
  
function NewCharWindow:Constructor( )
   
    --I create new charicter dialog and set window basics
    Turbine.UI.Lotro.Window.Constructor( self )
    self:SetPosition( 230, 150 )
    self:SetSize( 250, 175 )
    self:SetText( "New Charicter" )
    self:SetVisible( false )
     
    --I Setup first line (charicter name)
    self.Name = Turbine.UI.Label()
    self.Name:SetParent( self )
    self.Name:SetSize( 110, 40 )
    self.Name:SetPosition( 25, 40 )
    self.Name:SetForeColor( Turbine.UI.Color( 1, .8, .6 ) )
    self.Name:SetText( "Charicter Name:" )
   
    self.NameText = Turbine.UI.Lotro.TextBox()
    self.NameText:SetParent( self )
    self.NameText:SetPosition( 130, 40 )
    self.NameText:SetSize( 100, 20 )
    self.NameText:SetFont( Turbine.UI.Lotro.Font.Verdana12 ) 
    
    --I Setup second line (profesion 1)
    self.Prof1 = Turbine.UI.Label()
    self.Prof1:SetParent( self )
    self.Prof1:SetSize( 100, 40 )
    self.Prof1:SetPosition( 25, 65 )
    self.Prof1:SetForeColor( Turbine.UI.Color( 1, .8, .6 ) )
    self.Prof1:SetText( "First prof:" )
    
    self.Prof1Text = Turbine.UI.Lotro.TextBox()
    self.Prof1Text:SetParent( self )
    self.Prof1Text:SetPosition( 130, 65 )
    self.Prof1Text:SetSize( 100, 20 )
    self.Prof1Text:SetFont( Turbine.UI.Lotro.Font.Verdana12 )
    
    --I Setup Third line (Second profession)
    self.Prof2 = Turbine.UI.Label()
    self.Prof2:SetParent( self )
    self.Prof2:SetSize( 100, 40 )
    self.Prof2:SetPosition( 25, 90 )
    self.Prof2:SetForeColor( Turbine.UI.Color( 1, .8, .6 ) )
    self.Prof2:SetText( "Second Prof:" )
    
    self.Prof2Text = Turbine.UI.Lotro.TextBox()
    self.Prof2Text:SetParent( self )
    self.Prof2Text:SetPosition( 130, 90 )
    self.Prof2Text:SetSize( 100, 20 )
    self.Prof2Text:SetFont( Turbine.UI.Lotro.Font.Verdana12 )
    
    --I Setup Fourth Line (profesion 3)
    self.Prof3 = Turbine.UI.Label()
    self.Prof3:SetParent( self )
    self.Prof3:SetPosition( 25, 115 )
    self.Prof3:SetSize( 100, 50 )
    self.Prof3:SetForeColor( Turbine.UI.Color( 1, .8, .6 ) )
    self.Prof3:SetText( "Third Prof:" )
    
    self.Prof3Text = Turbine.UI.Lotro.TextBox()
    self.Prof3Text:SetParent( self )
    self.Prof3Text:SetPosition( 130, 115 )
    self.Prof3Text:SetSize( 100, 20 )
    self.Prof3Text:SetFont( Turbine.UI.Lotro.Font.Verdana12 )
    
    --I Setup save button
    self.SaveBut = Turbine.UI.Lotro.Button()
    self.SaveBut:SetParent( self )
    self.SaveBut:SetPosition( 25, 140 )
    self.SaveBut:SetSize( 100, 50 )
    self.SaveBut:SetText( "Save" )

    function NewCharWindow:SaveChar( other )
        --I builds the character information template
        data = {}
        data.name = self.NameText:GetText()
        data.prof1 = self.Prof1Text:GetText()
        data.prof2 = self.Prof2Text:GetText()
        data.prof3 = self.Prof3Text:GetText()
        data.shoplist = ""
        other:MakeBut( data )
        Clear()
        self:SetVisible( false )
    end

    --Setup Clear Button
    self.ClearBut = Turbine.UI.Lotro.Button()
    self.ClearBut:SetParent( self )
    self.ClearBut:SetSize( 100, 50 )
    self.ClearBut:SetPosition( 130, 140 )
    self.ClearBut:SetText( "Clear" )
    self.ClearBut.Click = function( sender, args ) Clear() end

    function Clear()
        self.NameText:SetText( nil )
        self.Prof1Text:SetText( nil )
        self.Prof2Text:SetText( nil )
        self.Prof3Text:SetText( nil )
    end
end