import "Turbine"
import "Turbine.UI"
import "Turbine.UI.Lotro"
import "Turbine.Utils"

ShopWindow = class( Turbine.UI.Window )

function ShopWindow:Constructor( )
    Turbine.UI.Lotro.Window.Constructor( self )

    --Build Window Base.
    self:SetSize( 300, 210 )
    self:SetPosition( 230, 300 )
    self:SetVisible( false )
    self:SetText( "Shopping list" )
    
    self.slist = Turbine.UI.Lotro.TextBox()
    self.slist:SetPosition( 25, 40 )
    self.slist:SetSize( 250, 125 )
    self.slist:SetParent( self )
    
    self.sbut = Turbine.UI.Lotro.Button()
    self.sbut:SetSize( 60, 20 )
    self.sbut:SetPosition( 25, 170 )
    self.sbut:SetParent( self )
    self.sbut:SetText( "Save" )
    self.sbut.Click = function( sender, args ) self:SetVisible( false ) end
    
    self.cbut = Turbine.UI.Lotro.Button()
    self.cbut:SetSize( 60, 20 )
    self.cbut:SetPosition( 215, 170 )
    self.cbut:SetParent( self )
    self.cbut:SetText( "Clear" )
    self.cbut.Click = function( sender, args ) self:Clear() end
    
end

function ShopWindow:Clear( )
    self.slist:SetText( "" )
    self:SetVisible( false )
end

